function XFormsUINode100(parentRef,node) {
  var ri;
  var xid;
  var uniqueId
  var parent;
  var childNodes;
  var type;
  var formid;
  
  var valid;
  var readonly;
  var relevant;
  var required;
  var constraint;
  var uiRef;
  var iRef;
  this.iref=null;

  this.parent = parentRef;

  this.isReadOnly = XFormsUINode100_isReadOnly;
  this.isRelevant = XFormsUINode100_isRelevant;
  this.isRequired = XFormsUINode100_isRequired;
  this.isInRange  = XFormsUINode100_isInRange;
  this.isValid    = XFormsUINode100_isValid;
  this.destruct = XFormsUINode100_destruct;
  this.appendChild = XFormsUINode100_appendChild;
  this.refreshUI = XFormsUINode100_refreshUI;
  this.initUI = XFormsUINode100_initUI;
  this.initAllUI = XFormsUINode100_initAllUI;
  this.refreshAllUI = XFormsUINode100_refreshAllUI;
  this.setUIRef = XFormsUINode100_setUIRef;
  this.getUIRef = XFormsUINode100_getUIRef;
  this.getChildNodes = XFormsUINode100_getChildNodes;
  this.removeChild = XFormsUINode100_removeChild;
  this.removeAllChildren = XFormsUINode100_removeAllChildren;
  
  this.getParent= XFormsUINode100_getParent;
  
  this.isAllComponentsLoaded = XFormsUINode100_isAllComponentsLoaded;
  this.value = "";
  this.childNodes = new Array();
  this.eventArray = new Array();
  this.getType = XFormsUINode100_getType;
  this.getUniqueId = XFormsUINode100_getUniqueId;
  this.getRi = XFormsUINode100_getRi;
  this.getXid = XFormsUINode100_getXid;
  this.isPageLoaded = XFormsUINode100_isPageLoaded;   
  this.appendChild = XFormsUINode100_appendChild;     
  // Build the tree
  if (parentRef!=null) {
    this.parent.appendChild(this);
  }
  this.type = node.nodeName;
  this.ri= node.getAttribute("xformsri");
  this.xid= node.getAttribute("xid");
  this.formid= node.getAttribute("xformsid");
  this.id= node.getAttribute("xformsuiid");
  this.uniqueId = this.id + this.ri;
  xformsfw[this.formid].registerUINode(this.uniqueId, this);
}


function XFormsUINode100_getParent() { 
  return this.parent;
}

function XFormsUINode100_getType() { 
  return this.ctype;
}

function XFormsUINode100_getUniqueId() { 
  return this.uniqueId;
}

function XFormsUINode100_getRi() { 
  return this.ri;
}
function XFormsUINode100_getXid() { 
  return this.xid;
}

function XFormsUINode100_setUIRef(element) { 
  this.uiRef=element;
}
function XFormsUINode100_getUIRef() { 
  return this.uiRef;
}

function XFormsUINode100_getChildNodes(val) { 
  return this.childNodes;
}


function XFormsUINode100_appendChild(nodeRef){
  this.childNodes[this.childNodes.length] = nodeRef;
  return nodeRef;
}

function XFormsUINode100_removeAllChildren(){
  var i;
  for (i=0;i<this.childNodes.length;i++) {
    this.removeChild(this.childNodes[i]);
  }
  this.childNodes.length=0;
}  

function XFormsUINode100_removeChild(node){
  XFormsUtil100.removeArrayItem(this.childNodes, node);
  node.destruct();
}  
function XFormsUINode100_destruct(){
  var i;
  
  //this.uiRef.destruct();
  for (i=0;i<this.childNodes.length;i++) {
    this.childNodes[i].destruct();
    this.childNodes[i]=null;
  }
  this.childNodes.length=0;
  xformsfw[this.formid].unregisterUINode(this.uniqueId);
  //this.delete;
}

function XFormsUINode100_isAllComponentsLoaded() {
  var res = true;
  var i;
  if (this.mustBind==true) {
    if (this.getUIRef() == null ) {
      //XFormsUtil100.alert("-" + this.xid);
      res = false;
    }
  }
  if (this.ctype!="Repeat") {
    i=0;
    while (res && i< this.childNodes.length) {
      //alert("doing refresh on: " + this.childNodes[i].xid);
      var node = this.childNodes[i];
      if (node != null) {
        res = res && node.isAllComponentsLoaded();
      }
      i++;
    }
  }
  return res;
}

function XFormsUINode100_isPageLoaded() {
  var res = true;
  var i;
  if (this.getUIRef() == null ) {
    XFormsUtil100.alert ("Waiting for: " + this.type);
    res = false;
  }

  i=0;
  while (res && i< this.childNodes.length) {
    var node = this.childNodes[i];
    if (node != null) {
      res = res && node.isPageLoaded();
    }
    i++;
  }  
  return res;
}

function XFormsUINode100_refreshUI(){
 // try {
    this.getUIRef().refresh(); 
 // }catch (e) {
 //   alert("Unable to refresh: " + this.type);
 // }
}

function XFormsUINode100_initUI(){
  if (this.xid!=null) {
    this.iref=xformsfw[this.formid].getINode(this.xid + this.ri);
  }
  try {
    this.getUIRef().init(); 
  }catch (e) {
    alert("Unable to init: " + this.ctype + ":" + this.xid + this.ri + "\non " + this.uiRef + "\n");
  }
}


function XFormsUINode100_refreshAllUI(){
  this.refreshUI();
  if (this.ctype!="Repeat") {
    var i;
    for (i=0;i<this.childNodes.length;i++) {
      this.childNodes[i].refreshAllUI();
    }
  }
}   

function XFormsUINode100_initAllUI(){
  this.initUI();
  if (this.ctype!="Repeat") {
    var i;
    for (i=0;i<this.childNodes.length;i++) {
      this.childNodes[i].initAllUI();
    }
  }
}   

function XFormsUINode100_isReadOnly() {
  return this.readonly;
}
function XFormsUINode100_isRelevant() {
  return this.relevant;
}
function XFormsUINode100_isRequired() {
  return this.required;
}
function XFormsUINode100_isInRange(){
  return this.inrange;
}
function XFormsUINode100_isValid(){
  return this.valid;
}
function XFormsUINode100_getEventPriorities(){
  return this.eventPriorities;
}  