/*
 * Copyright (c) 1993-1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * The Java source code is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You shall
 * not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.

 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */
/*
 * @(#)monitor_md.h	1.11 95/11/19
 *
 */

/*-
 * NetWare dependent API
 */

#ifndef	_NW_MONITOR_MD_H_
#define	_NW_MONITOR_MD_H_

#include "threads_md.h"
#include "mutex_md.h"
#include "condvar_md.h"

#define SYS_MID_NULL ((sys_mon_t *) 0)

typedef struct sys_mon {
    mutex_t mutex;	                /* Mutex for this monitor */
    condvar_t condvar;              /* Condition variable for this monitor */
    sys_thread_t *monitor_owner;    /* Thread currently owning this monitor */
    unsigned int entry_count;	    /* Monitor entry count */
} sys_mon_t;

#endif	/* !_NW_MONITOR_MD_H_ */
