/* **************************************************************************

  $Archive: /njcl_v2/src/com/novell/service/jncp/NDSException.java $
  $Revision: 7 $
  $Modtime: 1/28/00 11:07a $
 
  Copyright (c) 1998 Novell, Inc.  All Rights Reserved.

  THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
  TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
  COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
  EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
  OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
  CRIMINAL AND CIVIL LIABILITY.

****************************************************************************/

/* @(#)NDSException.java        1.00  96/11/11    NSI Development Team
 *
 */

package com.novell.service.jncp;

/**
 * Exceptions caused by NDS errors inherit from NDSException<p>
 *
 * @version     1.00, 23 Oct 1996
 * @author      NSI Development Team
 */

public class NDSException extends NSIException
{
   //************************************************************************
   // Constructors
   //************************************************************************

   /**
    * Constructs an NDSException with no detail message.
    * A detail message is a String that describes this particular exception.
    */
   public NDSException()
   {
      super(0);
   }

   /**
    * Constructs an NDSException with the specified detail message.
    * A detail message is a String that describes this particular exception.
    * @param s the detail message
    */
   public NDSException(String s)
   {
      super(s);
   }

   /**
    * Constructs an NDSException with an ccode-based generic detail message.
    * A detail message is a String that describes this particular exception.
    * @param c the ccode value
    */
   public NDSException(int c)
   {
      super(c);
   }
}


