
/* **************************************************************************

  $Archive: /njcl_v2/src/com/novell/service/nds/NdsObjectInfo.java $Revision:
  $Modtime:

  Copyright (c) 1998 Novell, Inc.  All Rights Reserved.

  THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
  TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
  COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
  EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
  OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
  CRIMINAL AND CIVIL LIABILITY.

****************************************************************************/

package com.novell.service.nds;



/** @internal
 *
 */
public interface NdsObjectInfo
{
   /**
    * Entry flag definitions used by 
    *    DSV_LIST, DSV_READ_ENTRY_INFO, DSV_SEARCH. 
    */
   public static final int DS_ALIAS_ENTRY         = 0x0001;
   public static final int DS_PARTITION_ROOT      = 0x0002;
   public static final int DS_CONTAINER_ENTRY     = 0x0004;
   public static final int DS_CONTAINER_ALIAS     = 0x0008;
   /* only returned by DSV_LIST */
   public static final int DS_MATCHES_LIST_FILTER = 0x0010;
   public static final int DS_REFERENCE_ENTRY     = 0x0020;
   public static final int DS_40X_REFERENCE_ENTRY = 0x0040;
   public static final int DS_BACKLINKED          = 0x0080;
   public static final int DS_NEW_ENTRY           = 0x0100;
   public static final int DS_TEMPORARY_REFERENCE = 0x0200;
   public static final int DS_AUDITED             = 0x0400;
   public static final int DS_ENTRY_NOT_PRESENT   = 0x0800;

   /**
    *
    */
   public int getObjectFlags ();

   /**
    *
    */
   public int getSubordinateCount ();

   /**
    *
    */
   public int getModificationTime ();

   /**
    *
    */
   public String getBaseClass ();

   /**
    *
    *
   public String getEntryRDN (); */

   /**
    *
    *
   public String getEntryDN (); */

   /**
    *
    */
	public boolean isManagementRoot ();

} /* NdsObjectInfo */


