/* **************************************************************************

  $Archive: /njcl/src/com/novell/service/nds/ldap/LdapClassName.java $
  $Revision: 1 $
  $Modtime: 3/02/98 1:37p $
 
  Copyright (c) 1998 Novell, Inc.  All Rights Reserved.

  THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
  TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
  COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
  EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
  OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
  CRIMINAL AND CIVIL LIABILITY.

****************************************************************************/
package com.novell.service.nds.ldap;

import com.novell.service.nds.*;

/**
@internal
LdapClassName is an Adapter for NdsClassName.
*/
public final class LdapClassName
   extends NdsClassName
   implements LdapAttributeValue
{

   /**
   * Constructs an LdapClassName adapter for an NdsClassName.
   *
   * @param   value     Ldap string representation of ClassName.
   */
   protected LdapClassName (
         String value)
   {
      this.value = new String(value);
   }

   /**
   * Constructs an LdapClassName adapter for an NdsClassName.
   *
   * @param   value     an NdsClassName object.
   */
   protected LdapClassName (NdsClassName value)
   {
      super (value);
   }

   /**
   * Returns an Ldap string representation of ClassName.
   *
   * @return   String containing Ldap string representation of ClassName.
   */
   public String toString ()
   {
      return this.value;
   }
}

