/* **************************************************************************

  $Archive: /njcl_v2/src/com/novell/service/nds/naming/OperationAbortedException.java $
  $Revision: 3 $
  $Modtime: 1/21/00 11:52a $
 
  Copyright (c) 1998 Novell, Inc.  All Rights Reserved.

  THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
  TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
  COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
  EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
  OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
  CRIMINAL AND CIVIL LIABILITY.

****************************************************************************/

package com.novell.service.nds.naming;

import javax.naming.*;

/**
 *  Exception thrown from a createSubContext or destroySubcontext
 *  on an NdsPartitionTreeRootContext object when the operation
 *  is aborted via a call to abortOperations().
 */
public class OperationAbortedException extends NamingException
{
   /**
    * Constructs an OperationAbortedException object based on a
    * string paramter containing the name of the operation that
    * is aborted.
    *
    * @param oprn The operation that is aborted.
    */
    public OperationAbortedException(String oprn)
    {
        super(oprn );
    }
}
