/* **************************************************************************

  $Archive: /njcl_v2/src/com/novell/service/session/InvalidStateException.java $
  $Revision: 5 $
  $Modtime: 1/24/00 7:59p $

  Copyright (c) 1997 Novell, Inc.  All Rights Reserved.

  THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
  TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
  COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
  EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
  OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
  CRIMINAL AND CIVIL LIABILITY.

****************************************************************************/
package com.novell.service.session;

import com.novell.service.jncpv2.clx.*;

/**
 * Thrown by any Session method when the Session is not in a valid
 * state for that operation.
 */
public class InvalidStateException extends SessionException
{
   /**
    * Constructs an InvalidStateException with the specified detail message.
    * A detail message is a String that describes this particular exception.
    *
    * @param s The detail message describing the exception.
    */
   public InvalidStateException
   (
      String s
   )
   {
      super(s);
   }

   /**
    * Constructs an InvalidStateException with the specified detail
    * message a root-cause exception. The root cause exception can be
    * retrieved using the getRootCause() method.
    *
    * @param s The detail message describing the exception.
    * @param rootException The root-cause exception.
    */
   public InvalidStateException
   (
      String s,
      Throwable rootException
   )
   {
      super(s, rootException);
   }
}

