/* **************************************************************************

  $Archive: /njcl/src/com/novell/java/security/ModifyTokensCancelledException.java $
  $Revision: 6 $
  $Modtime: 10/22/98 10:11a $

  Copyright (c) 1997-1998 Novell, Inc.  All Rights Reserved.

  THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL PROPRIETARY
  AND TRADE SECRET INFORMATION OF NOVELL, INC. ACCESS  TO  THIS  WORK IS
  RESTRICTED TO (I) NOVELL, INC.  EMPLOYEES WHO HAVE A NEED TO  KNOW HOW
  TO  PERFORM  TASKS WITHIN  THE SCOPE  OF  THEIR   ASSIGNMENTS AND (II)
  ENTITIES OTHER  THAN  NOVELL, INC.  WHO  HAVE ENTERED INTO APPROPRIATE
  LICENSE   AGREEMENTS.  NO  PART  OF  THIS WORK MAY BE USED, PRACTICED,
  PERFORMED COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED,
  CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED,  RECAST, TRANSFORMED
  OR ADAPTED  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.  ANY USE
  OR EXPLOITATION  OF  THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE
  PERPETRATOR  TO CRIMINAL AND CIVIL LIABILITY.

****************************************************************************/
package com.novell.java.security;

/**
 * Thrown when the token modification procedure is cancelled.
 *
 * @see ModifyTokensException
 *
 * @author Jan Sture Nielsen
 * @version 1.0.0
 */
public class ModifyTokensCancelledException extends ModifyTokensException
{
   /**
    * The default constructor.
    */
   public ModifyTokensCancelledException()
   {
      super(I2L.getString(XMsg.MODIFY_TOKENS_CANCELLED));
   }

   /**
    * Constructor with a message.
    *
    * @param message A message associated with the exception.
    */
   public ModifyTokensCancelledException(String message)
   {
      super(message);
   }

   /**
    * Constructor with a message and a root cause exception.
    *
    * @param message   A message associated with the exception.
    * @param exception The root cause exception.
    */
   public ModifyTokensCancelledException(String message,java.lang.Throwable exception)
   {
      super(message,exception);
   }

   /**
    * Constructor with a root cause exception.
    *
    * @param exception The root cause exception.
    */
   public ModifyTokensCancelledException(java.lang.Throwable exception)
   {
      this(I2L.getString(XMsg.MODIFY_TOKENS_CANCELLED),exception);
   }
}
